/*
 *   Copyright 2012 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

/**
 * @file   debug.h
 * @author Ioannis Koutras (joko@microlab.ntua.gr)
 * @date   September 2012
 * @brief  Debug functions
 */

#ifndef DEBUG_H
#define DEBUG_H
#include "dmm_config.h"

#include "dmmlib/allocator.h"

#ifdef FL_RB_ONLY
#include "dmmlib/raw_block.h"
#endif /* FL_RB_ONLY */

void get_raw_blocks(allocator_t *allocator);

// FIXME separate debugging functions for different raw blocks
#ifdef FL_RB_ONLY
void get_memory_blocks(raw_block_header_t *raw_block);
#endif /* FL_RB_ONLY */

#endif /* DEBUG_H */
