/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

/**
 * \file        add_block.h
 * \author      Ioannis Koutras (joko@microlab.ntua.gr)
 * \date        January, 2012
 *  
 * \brief Add a block in a linked list.
 */

#ifndef ADD_BLOCK_H
#define ADD_BLOCK_H

#include "dmm_config.h"

#ifdef LIFO_SORT_POLICY
#include "freelist/linked_lists/lifo_order.h"
#endif /* LIFO_SORT_POLICY */

#ifdef FIFO_SORT_POLICY
#include "freelist/linked_lists/fifo_order.h"
#endif /* LIFO_SORT_POLICY */

#ifdef SIZE_SORT_POLICY
#include "freelist/linked_lists/size_order.h"
#endif /* LIFO_SORT_POLICY */

#ifdef ADDRESS_SORT_POLICY
#include "freelist/linked_lists/address_order.h"
#endif /* LIFO_SORT_POLICY */

#endif /* ADD_BLOCK_H */

