/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#include "block_header.h"
#include "linked_lists/fifo_order.h"

void add_block_fifo_order(
#ifdef COUNT_HOPS
        heap_t *heap,
#endif /* COUNT_HOPS */
        void **block,
        void **head_node,
        void **tail_node) {
    /* The tail node is updated only during add_block().
     * As a result, it is required to check the head node to see if the list is
     * empty.
     */
    if(*head_node == NULL || *tail_node == NULL) {
        *head_node = *block;
    } else {
#ifdef BLOCKS_IN_DLL
        set_previous(*block, *tail_node);
#endif /* BLOCKS_IN_DLL */
        set_next(*tail_node, *block);
    }
    *tail_node = *block;
    set_next(*block, NULL);
}

